	ORG 00H
START:  LJMP MAIN_PGR ;GO TO MAIN PROGRAMME
 
   	ORG 002FH
MAIN_PGR: 
	MOV A, # 38H ;INITIALIZE LCD
 	LCALL WR_LCD
 	MOV A, #0FH
 	LCALL WR_LCD
 	MOV A, #06H
 	LCALL WR_LCD
 	MOV A, #01H
 	LCALL WR_LCD
 	MOV A, #80H
 	LCALL WR_LCD
 	MOV A, #53H ;WRITE DATATO LCD
 	LCALL LCD_RAM ;i.e., STANDBYMODE
 	MOV A, #54H
 	LCALL LCD_RAM
 	MOV A, #41H
 	LCALL LCD_RAM
 	MOV A, #4EH
 	LCALL LCD_RAM
 	MOV A, #44H
 	LCALL LCD_RAM
 	MOV A, #42H
 	LCALL LCD_RAM
 	MOV A, #59H
 	LCALL LCD_RAM
 	MOV A, #0B0H
 	LCALL LCD_RAM
 	MOV A, #0C0H ;JUMP TO 9TH POSITION
 	LCALL WR_LCD ;OR SECOND LINE
 	MOV A, #4DH ;ENTER DATA AGAIN
 	LCALL LCD_RAM
 	MOV A, #4FH
 	LCALL LCD_RAM
 	MOV A, #44H
 	LCALL LCD_RAM
 	MOV A, #45H
 	LCALL LCD_RAM
 	LJMP SCAN ;GO TO 010AH

 	ORG 00A0H
WR_LCD: LCALL SETT ;CHECK FOR READY STATUS OF LCD
 	MOV P1,A ;MOVE CONTENTS OF A TO PORT 1
 	CLR P3.0 ;WRITE COMMANDS TO LCD
 	CLR P3.1
 	SETB P3.7
 	CLR P3.7
 	RET ;RETURN TO PROGRAMME

 	ORG 00C0H
LCD_RAM: 
	LCALL SETT ;CHECK READY STATUS OF LCD
 	MOV P1,A ;MOVE CONTENS OF A TO PORT 1
	SETB P3.0 ;WRITE TO DISPLAY RAM OF LCD00C7 C2B1 53 CLR P3.1
 	SETB P3.7
 	CLR P3.7
 	RET

	ORG 00F0H
SETT: 	CLR P3.7
 	MOV P1, #0FFH ;SET PORT1 FOR INPUT
 	NOP ;DELAY
 	CLR P3.0
	SETB P3.1
L1: 	CLR P3.7
 	SETB P3.7
	;JB P1.7,L1 ;IF NOT READY JUMP TO 00FA H
	CLR P3.7
	RET ;BACK TO PROGRAMME
	

	ORG 010AH
SCAN: 	SETB 76H ;SET USER FLAGS
	SETB 77H
	SETB 78H
	MOV P2,#0FFH ;SET PORT2 FOR INPUT
L4:	JNB P2.4,L2 ;IF H/V THEN GOTO 0136 H
	JNB P2.3,L3 ;IF L/V THEN GOTO 018B H
	JNB P2.0,L4 ;SCAN FOR TANK TO BE EMPTY
	SJMP L130 ;GOTO 0130 H
LOOP:   LCALL TMR_10MIN ;CALL 10 MIN.TIMER
	JNB 78H,L3 ;L/V THEN GOTO 018B H
	JNB 77H,L2 ;H/V THEN GOTO 0136 H
	JB 76H,L5 ;DRY SUMP THEN GOTO 0188 H
	JB P2.2,$ ;WAIT UNTILL TANK FULL
LOOP1: 	LJMP TANK_FULL ;GOTO TANK FULL DISPLAY
L130: 	CLR P3.5 ;START MOTOR
	LJMP DIS_M_ON ;DISPLAY MOTOR ON
	NOP ;BLANK SPACE
L2: 	LCALL DLY_2SEC ;WAIT FOR 2 SECONDS
	JB P2.4,L4 ;STILL H/V THEN GOTO 0113 H
LOOP2:  SETB P3.5 ;H/V THEN OFF MOTOR
	NOP
	NOP
	LCALL INI_LCD ;INITIALIZE LCD
 	MOV A, #48H ;DISPLAY HIGHVOLTAGE
 	LCALL LCD_RAM
	MOV A, #49H
	LCALL LCD_RAM
	MOV A, #47H
	LCALL LCD_RAM
	MOV A, #48H
	LCALL LCD_RAM
	MOV A, #0B0H
	LCALL LCD_RAM
	MOV A, #56H
	LCALL LCD_RAM
	MOV A, #4FH
	LCALL LCD_RAM
	MOV A, #04CH
	LCALL LCD_RAM
	MOV A, #0C0H ;MOVE TO 9TH CHARACTER
	LCALL WR_LCD
	MOV A, #54H
	LCALL LCD_RAM
	MOV A, #41H
	LCALL LCD_RAM
	MOV A, #47H
	LCALL LCD_RAM
	MOV A, #45H
	LCALL LCD_RAM
	LJMP CHK_HV ;GOTO 0490 H
	NOP ;BLANK SPACE
L5: 	LJMP M_STOP ;GOTO 0226 H
L3: 	LCALL DLY_2SEC ;WAIT FOR 2 SECONDS
	JB P2.3,L4 ;VOLTAGE OK THEN GOTO 0113 H
LOOP3:	SETB P3.5 ;STOP MOTOR IF ON
	LCALL INI_LCD ;INITIALIZE LCD
	MOV A, #04CH ;DISPLAY LOWVOLTAGE
	LCALL LCD_RAM
	MOV A, #04FH
	LCALL LCD_RAM
	MOV A, #57H
	LCALL LCD_RAM
	MOV A, #0B0H
	LCALL LCD_RAM
	MOV A, #56H
	LCALL LCD_RAM
	MOV A, #04FH
	LCALL LCD_RAM
	MOV A, #04CH
	LCALL LCD_RAM
	MOV A, #54H
	LCALL LCD_RAM
	MOV A, #0C0H ;GOTO 9TH CHARACTER
	LCALL WR_LCD
	MOV A, #41H ;START DISPLAY AGAIN
	LCALL LCD_RAM
	MOV A, #47H
	LCALL LCD_RAM
	MOV A, #45H
	LCALL LCD_RAM
	LJMP CHK_LV ;GOTO 04B0 H 01D5 00 150 
	NOP
	NOP
	NOP

	ORG 01D8H
DLY_2SEC: 
	MOV R3, #03H
L8: 	MOV R4, #0FFH
L7: 	MOV R5, #0FFH
L6: 	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	DJNZ R5,L6 ;01DEH
	DJNZ R4,L7 ;01DCH
	DJNZ R3,L8 ;01DAH
	RET ;BACK TO PROGRAMME

	ORG 0226H
M_STOP: SETB P3.5 ;STOP MOTOR
	LCALL INI_LCD ;INITIALIZE LCD
	MOV A, #44H ;START FILLING DISPLAY RAM OF LCD
	LCALL LCD_RAM
	MOV A, #52H
	LCALL LCD_RAM
	MOV A, #59H
	LCALL LCD_RAM
	MOV A, #0B0H
	LCALL LCD_RAM
	MOV A, #53H
	LCALL LCD_RAM
	MOV A, #055H
	LCALL LCD_RAM
	MOV A, #04DH
	LCALL LCD_RAM
	MOV A, #50H
	LCALL LCD_RAM
	MOV A, #0C0H ;MOVE TO 9TH CHARACTER OF LCD
	LCALL WR_LCD
	MOV A, #31H ;START WRITING AGAIN
	LCALL LCD_RAM
	LJMP L300 ;GOTO 0300 H

TANK_FULL:
	SETB P3.5 ;STOP MOTOR
	NOP ;BLANK SPACES FOR FURTHER EXPANSION
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	LCALL INI_LCD ;INITIALIZE LCD
	MOV A, #54H ;WRITE TO DISPLAY RAM OF LCD
	LCALL LCD_RAM
	MOV A, #41H
	LCALL LCD_RAM
	MOV A, #4EH
	LCALL LCD_RAM
	MOV A, #4BH
	LCALL LCD_RAM
	MOV A, #0B0H
	LCALL LCD_RAM
	MOV A, #46H
	LCALL LCD_RAM
	MOV A, #55H
	LCALL LCD_RAM
	MOV A, #4CH
	LCALL LCD_RAM
	MOV A, #0C0H ;GOTO 9TH CHARACTER OF LCD
	LCALL WR_LCD
	MOV A, #4CH ;START DISPLAYING AGAIN
	LCALL LCD_RAM
	LCALL DLY_2SEC ;DISPLAY IT FOR 2 SECONDS
	LJMP START ;GOTO STANDBY MODE
	
	ORG 02B3H
	INI_LCD:MOV A, # 38H
	LCALL WR_LCD
	MOV A, #0FH
	LCALL WR_LCD
	MOV A, #06H
	LCALL WR_LCD
	MOV A, #01H
	LCALL WR_LCD
	MOV A, #80H
	LCALL WR_LCD
	RET ;BACK TO PROGRAMME
	NOP
	NOP
	NOP
DIS_M_ON: 
	LCALL INI_LCD ;INITIALIZE LCD
	MOV A, # 4DH ;WRITE INTO DISPLAY RAM OF LCD
	LCALL LCD_RAM
	MOV A, #04FH
	LCALL LCD_RAM
	MOV A, #54H
	LCALL LCD_RAM
	MOV A, #04FH
	LCALL LCD_RAM
	MOV A, #52H
	LCALL LCD_RAM
	MOV A, #0B0H
	LCALL LCD_RAM
	MOV A, #04FH
	LCALL LCD_RAM
	MOV A, #04EH
	LCALL LCD_RAM
	LJMP LOOP ;BACK TO MAIN PROGRAMME AT 011E H
	NOP
	NOP
L300: 	LCALL TMR_5MIN ;CALL 5 MINUTES TIMER
	LJMP MAIN ;GOTO MAIN PROGRAMME AT 0550 H
	
	ORG 0320H
TMR_5MIN: 
	MOV R2,#03H
L12: 	MOV R3, #0FFH
L11: 	MOV R4, #0FFH
L10: 	MOV R5, #0FFH
L9: 	NOP
	NOP
	NOP
	NOP
	DJNZ R5, L9 ;0328
	DJNZ R4, L10 ;0326
	DJNZ R3, L11 ;0324
	DJNZ R2, L12 ;0322
	RET ;BACK TO MAIN PROGRAMME
	
	ORG 0430H
L430: 	JNB P2.2,L43C ;IF TANK FULL GOTO 043C H
	JNB P2.4,L43F ;H/V THEN GOTO 043F H
L436: 	JNB P2.3,L448 ;L/V THEN GOTO 0448 H
L439: 	SJMP L430 ;GOTO 0430 H
	NOP
L43C: 	LJMP LOOP1 ;ACK TO MAIN PROGRAMME
L43F: 	LCALL DLY_2SEC ;WAIT FOR 2 SECONDS
	JB P2.4, L436 ;IF NOT H/V THEN GOTO 0436 H
	LJMP LOOP2 ;H/V THEN GOTO 013C H
L448: 	LCALL DLY_2SEC ;WAIT FOR 2 SECONDS
	JB P2.3, L439 ;IF NOT L/V THEN GOTO 0439 H
	LJMP LOOP3 ;IF L/V THEN GOTO 0191 H

	ORG 0490H
CHK_HV: NOP
	NOP
L492: 	LCALL DLY_2MIN ;WAIT FOR 2 MINUTES
	JNB P2.4,L492 ;CHECK FOR H/V AGAIN
	LJMP START ;GOTO START	AGAIN
 
	ORG 04B0H
	CHK_LV: NOP
	NOP
L4B2: 	LCALL DLY_2MIN ;WAIT FOR 2 MINUTES
	JNB P2.3, L4B2 ;CHECK FOR L/V AGAIN
	LJMP START ;GOTO START AGAIN
	
	ORG 0500H
DLY_2MIN:
 	MOV R2, #0FFH
L502: 	MOV R3,#0FFH
L504: 	MOV R4,#0FFH
L506: 	NOP
	NOP
	NOP
	NOP
	DJNZ R4, L506
	DJNZ R3, L504
	DJNZ R2, L502
	RET ;BACK TO MAIN PROGRAMME

	ORG 054DH
M_START: 
	LJMP SUB_BR ;SUB BRANCH DUE TO SPACE PROBLEM
MAIN: 	JNB P2.4, L59A ;CHECK FOR HIGH VOLTAGE
	JNB P2.3, L5A3 ;CHECK FOR LOW VOLTAGE
	CLR P3.5 ;IF VOLTAGE OK THEN START MOTOR
	LCALL INI_LCD ;INITIALIZE LCD
	MOV A, #04DH ;START WRITING TO DISPLAY RAM OF LCD
	LCALL LCD_RAM
	MOV A, #04FH
	LCALL LCD_RAM
	MOV A, #54H
	LCALL LCD_RAM
	MOV A, #4FH
	LCALL LCD_RAM
	MOV A, #52H
	LCALL LCD_RAM
	MOV A, #0B0H
	LCALL LCD_RAM
	MOV A, #4FH
	LCALL LCD_RAM
	MOV A, #4EH
	LCALL LCD_RAM
	LCALL TMR_10MIN ;ENTER INTO 10 MINUTES TIMER
	JNB 78H, C_LV; 05A9H ;LOW VOLTAGE THEN GOTO 05A9 H
	JNB 77H, C_HV; 05A0H ;HIGH VOLTAGE THEN GOTO 05A0 H
	JB 76H, DRY ;05ACH ;IF TANK DRY THEN GOTO 05AC H
L58F: 	JNB P2.2, M_START ;TANK FULL THEN GOTO 054D H
	JNB P2.4, L59A ;HIGH VOLTAGE THENGOTO 059A H
L595: 	JNB P2.3, L5A3 ;LOW VOLTAGE THEN GOTO 05A3 H
L598: 	SJMP L58F ;REPEAT FROM 058F H
L59A: 	LCALL DLY_2SEC ;WAIT FOR 2 SECONDS
	JB P2.4, L595 ;IF NOT H/V THEN GO BACK TO 0595 H
C_HV:	LJMP LOOP2 ;STILL H/V THEN GOTO 013C H
L5A3: 	LCALL DLY_2SEC ;WAIT FOR 2 SECONDS
	JB P2.3, L598 ;IF NOT L/V THEN GO BACK TO 0598 H
C_LV: 	LJMP LOOP3 ;STILL L/V THEN GOTO 0191 H
DRY: 	SETB P3.5 ;STOP MOTOR
	LCALL INI_LCD ;INITIALIZE LCD
	MOV A, #44H ;START WRITING TO DISPLAY RAM OF LCD
	LCALL LCD_RAM
	MOV A, #52H
	LCALL LCD_RAM
	MOV A, #59H
	LCALL LCD_RAM
	MOV A, #0B0H
	LCALL LCD_RAM
	MOV A, #53H
	LCALL LCD_RAM
	MOV A, #55H
	LCALL LCD_RAM
	MOV A, #4DH
	LCALL LCD_RAM
	MOV A, #50H
	LCALL LCD_RAM
	MOV A, #0C0H ;GOTO 9TH CHARACTER OF LCD
	LCALL WR_LCD
	MOV A, #32H ;START WRITING AGAIN
	LCALL LCD_RAM
	LCALL TMR_5MIN ;WAIT FOR 5 MINUTES
	JNB P2.4,HV ; 0630H ;H/V THEN GOTO 0630 H
	JNB P2.3,LV ; 0639H ;L/V THEN GOTO 0639 H
	CLR P3.5 ;IF VOLTAGE OK THEN START MOTOR
	LCALL INI_LCD ;INITILIZE LCD
	MOV A, #4DH ;START WRITING TO DISPLAY RAM OF LCD
	LCALL LCD_RAM
	MOV A, #4FH
	LCALL LCD_RAM
	MOV A, #54H
	LCALL LCD_RAM
	MOV A, #4FH
	LCALL LCD_RAM
	MOV A, #52H
	LCALL LCD_RAM
	MOV A, #0B0H
	LCALL LCD_RAM
	MOV A, #4FH
	LCALL LCD_RAM
	MOV A, #4EH
	LCALL LCD_RAM
	LCALL TMR_10MIN ;GOTO	MINUTES TIMER
	JNB 78H, L63F ;L/V THEN GOTO 063F H
	JNB 77H, L636 ;H/V THEN GOTO 0636
	JB 76H, L647 ;STILL DRY SUMP THEN GOTO 0647 H
L625: 	JNB P2.2, SUB_BR ;0642H ;TANK FULL THEN GOTO 0642 H
	JNB P2.4, HV ;0630H ;H/V THEN GOTO 0630 H
N_HV: 	JNB P2.3, LV ;0639H ;L/V THEN GOTO 0639 H
N_LV: 	SJMP L625 ;REPEAT FROM 0625 H
HV: 	LCALL DLY_2SEC ;WAIT FOR 2 SECONDS
	JB P2.4, N_HV ;062BH ;IF NOT H/V THEN GOTO 062B 
L636:	LJMP LOOP2 ;STILL H/V THEN GOTO 013C H
LV: 	LCALL DLY_2SEC ;WAIT FOR 2 SECONDS
	JB P2.3, N_LV ;062EH ;IF NOT L/V THEN GOTO 062E H
L63F: 	LJMP LOOP3 ;STILL L/V THEN GOTO 0191 H
SUB_BR: SETB P3.5 ;STOP MOTOR
	LJMP TANK_FULL ;TANK FULL THEN GOTO 0260 H
L647: 	SETB P3.5 ;STOP MOTOR
	NOP
	NOP
	LCALL INI_LCD ;INITIALIZE LCD
	MOV A, #44H ;START WRITING TO DISPLAY RAM OF LCD
	LCALL LCD_RAM
	MOV A, #52H
	LCALL LCD_RAM
	MOV A, #59H
	LCALL LCD_RAM
	MOV A, #0B0H
	LCALL LCD_RAM
	MOV A, #53H
	LCALL LCD_RAM
	MOV A, #55H
	LCALL LCD_RAM
	MOV A, #4DH
	LCALL LCD_RAM
	MOV A, #50H
	LCALL LCD_RAM
	MOV A, #0C0H ;GOTO 9TH CHARACTER OF LCD
	LCALL WR_LCD
	MOV A, #33H ;START WRITING AGAIN
	LCALL LCD_RAM
	SJMP $ ;STAY HERE UNTILL MANUAL RESET
	

	ORG 0750H
TMR_10MIN: 
	MOV R2, #05H
L752: 	MOV R3, #0FFH
L754: 	MOV R4, #0FFH
L756: 	MOV R5, #0FFH
L758:	NOP
	NOP
	NOP
	NOP
	NOP
	DJNZ R5, L758
	DJNZ R4, L756
	JNB P2.4,L770 ;H/V THEN GOTO 0670 H
L764: 	JNB P2.3, L778 ;L/V THEN GOTO 0678 H
L767: 	JNB P2.1, L780 ; NOT DRY SUMP THEN GOTO 0680 H
L76A: 	DJNZ R3, L754
	DJNZ R2, L752
	RET ;BACK TO MAIN PROGRAMME
	NOP
L770: 	LCALL DLY_2SEC ;WAIT FOR 2 SECONDS
	JNB P2.4, 0788H ;STILL H/V THEN GOTO 0788 H
	SJMP L764 ; NOT H/V THEN GOTO 0764 H
L778: 	LCALL DLY_2SEC ;WAIT FOR 2 SECONDS
	JNB P2.3, 078BH ;STILL L/V THEN GOTO 078B H
	SJMP L767 ;NOT L/V THEN GOTO 0767 H
L780: 	LCALL DLY_2SEC ;WAIT FOR 2 SECONDS
	JNB P2.1, 078EH ;STILL NOT DRY SUMP THEN GOTO 078E H
	SJMP L76A ;OTHERWISE GOTO 076A
	CLR 77H ;CLEAR FLAG 77H FOR H/V
	RET
	CLR 78H ;CLEAR FLAG 78H FOR L/V
	RET
	CLR 76H ;CLEAR FLAG 76H FOR DRY SUMP CHECK
	REt
	END












